uniform sampler2D Palette;
uniform mat4 transformMatrix;
uniform mat4 normalsMatrix;
uniform vec2 paletteRows;

void main()
{
	// Constant light parameters
	// TODO: Move these into uniforms to allow configuration
	vec3 ambient = vec3(0.6, 0.6, 0.6);
	vec3 diffuse = vec3(0.4, 0.4, 0.4);
	vec4 lightDirection = vec4(normalize(vec3(1, 0, 0.5)), 1.0);

	vec4 normal = normalsMatrix*(2.0*texture2D(Palette, vec2(gl_TexCoord[0].t, paletteRows.y)) - 1.0);
	vec3 intensity = ambient + diffuse*max(dot(normal, lightDirection), 0.0);
	vec4 color = texture2D(Palette, vec2(gl_TexCoord[0].s, paletteRows.x));

	gl_FragColor = vec4(intensity*color.rgb, color.a);
}
